! 
!  subroutines used by ffswk.f90
!
! Ying Zhou (ying.yingzhou@gmail.com)
! May 2013 
!
       subroutine read_eigf(l_mode)
       use constant_para
       use eigen_functions
       integer nlayr(NDISP),ls00r(NDISP)
       character(len=70) file_layer,file_eigf,file_model

       WW(:) = 0
       DW(:) = 0
       UU(:) = 0
       DU(:) = 0
       VV(:) = 0
       DU(:) = 0
       
! read model
       file_model = dir_eigen(1:len_trim(dir_eigen))//'/model'

       open(10,file=file_model)
       read(10,*)
       read(10,*)ifanis,tref,ifdeck
       read(10,*)maxlay,nic,noc,rx
       maxrec = 0
       do i = 1,maxlay
       read(10,*)ind,radius(i),rho(i),av(i),bv(i),Qk,Qmu,ah(i),bh(i),ani(i)
       if(radius(i) .ge. (6371000-depth_max)) maxrec = maxrec + 1
       enddo
       close(10)

       if(is_love .eq. 1) then
             file_layer =dir_eigen(1:len_trim(dir_eigen))//'/layer.love.0'
             file_eigf =dir_eigen(1:len_trim(dir_eigen))//'/eigf.love.0'
        endif
       if(is_love .eq. 2) then
             file_layer =dir_eigen(1:len_trim(dir_eigen))//'/layer.rayleigh.0'
             file_eigf =dir_eigen(1:len_trim(dir_eigen))//'/eigf.rayleigh.0'
        endif
        
       j = 1
       open(10,file=file_layer)
       read(10,*)
40     read(10,91,end=41)w4,acr,gcom,nlayr(j),ls00r(j),n
91     format(1x,e11.4,1x,f12.5,1x,f12.5,1x,i5,i5,i5)
       j = j + 1
       if(j .eq. NDISP) write(*,*)' increase dimension NDISP in ffswk.f90, abort!'
       if(j .eq. NDISP) stop
       goto 40
41    close(10)
      maxdisp = j - 1
      
        
       open(10,file=file_eigf,form='unformatted')

       ! nimos eigf format different from love.for / rayleigh.for

       do 500 k=1,maxdisp

       read(10)nord,l,vc,wmhz,tcom,gu,qmod,wdiff
       if(l.eq.l_mode) then
         vphaser = vc 
         gcomr   = gu 
         fl      = float(l) 
         w4      =  twopi * wmhz * 0.001
         wn      =  w4*RR0/vphaser
         omega = w4
         qinv = qmod
         nlay = nlayr(k)
         ls00 = ls00r(k)

! read eigenfunctions and apply normalization
         do i = 1,nlay
           il = ls00 + i - 1 - (maxlay-maxrec)
           if(il.gt.0) then  ! only top maxrec layers
              if(is_love .eq. 1)then
                  read(10) WW(il),DW(il)
                  WW(il) = WW(il)*w4*RR0*sqrt( fl*(fl+1)/(vc*gu) )
                  DW(il) = DW(il)*w4*RR0*sqrt( fl*(fl+1)/(vc*gu) )
              endif
              if(is_love .eq. 2) then
                  read(10) UU(il),DU(il),VV(il),DV(il)
                  VV(il) = VV(il)*w4*RR0*sqrt( fl*(fl+1)/(vc*gu) )
                  DV(il) = DV(il)*w4*RR0*sqrt( fl*(fl+1)/(vc*gu) )
                  UU(il) = UU(il)*w4*RR0*sqrt( 1.0/(vc*gu) )
                  DU(il) = DU(il)*w4*RR0*sqrt( 1.0/(vc*gu) )
              endif
           else
               read(10) ! read a line
            endif
         enddo
         goto 501  ! done if found the mode
       else  ! degree l does not match
         do i = 1,nlayr(k)
              read(10)  ! read a line
         enddo
       endif
500       continue
501     close(10)

       return
       end
       



       subroutine calc_synthetic_ray()        
       use eigen_functions
       use synthetic_ray
       complex  seis0,exptmp,wseis0,radiat0,cz
       real arrival
        
       wseis0 = cmplx(0,0)
       wseisbot = 0
       cz      = cmplx(0,0)
       
       cla = 90-scola
       clo = slong
       rla = 90-rcola
       rlo = rlong
       call distaz(cla,clo,rla,rlo,distdeg,az12,az21)
       dist = dist_act * pi/180
       tstart =  dist_act*D2K*1000/gcomr - 0.5*wintt
       write(*,*)'assuming following measurement window'
       write(*,*)tstart,'s  ',tstart+ wintt,'s  '
       write(*,*)
       call radiation(az12,radiat0)
       exptmp = exp((-1)*cc*(wn*dist+pi/4-pi/2*maslv) ) 
       ! attenuation
       exptmp = exptmp*exp(-0.5*dist*RR0*omega*qinv/gcomr)
       seis0   =  exptmp / sqrt(8*pi*wn*abs(sin(dist)))
       if(is_uvw.eq.1) seis0 = seis0*uu(maxrec)
       if(is_uvw.eq.2) seis0 = -cc* seis0*vv(maxrec)
       if(is_uvw.eq.3) seis0 = cc* seis0*ww(maxrec)
       wseis0 = seis0*radiat0 

! approximate tapering 
         tp = 1.0
         cz =  wseis0 * tp
         cz_conjg = conjg(cz)
         wseisbot = cz * cz_conjg

       return
       end


        subroutine radiation(ang,radiat)
        use eigen_functions
        use synthetic_ray 
        complex e1, e2, pt1, pt2, pt3, pt4, pt5,radiat
        real Mrr,Mtt,Mpp,Mrp,Mrt,Mtp

        e1 = cmplx( 0, 1)
        e2 = cmplx( 1, 0)
        Mrr= xmom(1)
        Mtt= xmom(2)
        Mpp= xmom(3)
        Mrt= xmom(4)
        Mrp= xmom(5)
        Mtp= xmom(6)
! find source location
        do i = 1, (maxlay-1)
        if(rs.gt.radius(i).and.rs.le.radius(i+1)) then
             is1 = i
             is2 = i+1
             source_factor = (rs-radius(is1)) /( radius(is2) - radius(is1) )
         endif
       enddo

        i_1 = is1-maxlay+maxrec
        i_2 = is2-maxlay+maxrec

         WWS = WW(i_1) + source_factor * (WW(i_2)-WW(i_1))
         DWS = DW(i_1) + source_factor * (DW(i_2)-DW(i_1))
         UUS = UU(i_1) + source_factor * (UU(i_2)-UU(i_1))
         DUS = DU(i_1) + source_factor * (DU(i_2)-DU(i_1))
         VVS = VV(i_1) + source_factor * (VV(i_2)-VV(i_1))
         DVS = DV(i_1) + source_factor * (DV(i_2)-DV(i_1))

! compute radiation
         M = 1
         theta = ang * pi /180.0 
         pt1 = (Mrr*DUS + (Mtt + Mpp)*(1/rs)*( UUS-0.5*wn*VVS )) *e1 
         pt2 = (-1)**M *(DVS-(1/rs)*VVS+wn*(1/rs)*UUS)*( Mrp*sin(theta) + Mrt*cos(theta) ) *e2 
         pt3 = (-1)*wn*(1/rs)*VVS * ( Mtp*sin(2*theta) + 0.5*(Mtt-Mpp)*cos(2*theta))  * e1 
         pt4 = (-1)**M *( DWS - (1/rs)*WWS ) * ( Mrt*sin(theta) - Mrp*cos(theta) ) * e2 
         pt5 = (-1)*wn*(1/rs)*WWS* ( 0.5*(Mtt-Mpp)*sin(2*theta) - Mtp*cos(2*theta) ) * e1         
         radiat =  (-1)*(pt1+pt2+pt3+pt4+pt5)/omega 
         radiat = radiat 
       return
       end


       subroutine  scatter(blo,bla)
       use eigen_functions
       use synthetic_ray 
       complex exptmp, wkntop
       complex seis,radiat
       real    akern(maxaniso)

       wkn(:,:) = 0 

       cla = 90-scola
       clo = slong
       rla = fla 
       rlo = flo
       call distaz(cla,clo,rla,rlo,distdeg1,az12,az21)
       call dis1(0,blo,distdeg1,dist1)
       call radiation(az12,radiat)
       cla = fla 
       clo = flo
       rla = 90-rcola
       rlo = rlong
       call distaz(cla,clo,rla,rlo,distdeg2,bz12,bz21)
       call dis2(0,blo,distdeg2,dist2)
       call angcal(blo,bla,sphi,ang2)
       sphi = sphi*pi/180
       ang2 = ang2*pi/180

       ! geometrical spreading
       exptmp = exp((-1)*cc*(wn*dist1+wn*dist2+pi/2) )
       ! attenuation
        exptmp = exptmp*exp(-0.5*dist1*RR0*omega*qinv/gcomr)
        exptmp = exptmp*exp(-0.5*dist2*RR0*omega*qinv/gcomr)

        geospread = abs(sin(dist1) * sin(dist2))

        seis = exptmp /( 8*pi*sqrt(wn*wn*geospread) )

        if(is_uvw.eq.1) seis =  seis * radiat
        if(is_uvw.eq.2) seis = -cc * seis * radiat
        if(is_uvw.eq.3) seis =  cc * seis * radiat

        ! min: bottom, max: topmost   surface
       lay_min = ls00 - (maxlay-maxrec)
       lay_max = ls00 + nlay-1 - (maxlay-maxrec)
       if(lay_min.lt.1) lay_min = 1

       ! taper value
        time1 = dist1*RR0/gcomr
        time2 = dist2*RR0/gcomr
        its   = nint((time1+time2-tstart)/dt)
        res   = (time1 + time2-tstart)/dt - its
        if(res.ge.0) tp = tarray(its) + (res)*(tarray(its+1)-tarray(its))
        if(res.lt.0) tp = tarray(its) + (res)*(tarray(its) - tarray(its-1) )
        if(its.lt.1 .or. its.gt.(maxlen) ) tp = 0   ! outside window

       do ly= lay_min, lay_max  
        call layer_coeff(sphi,ang2,ly,akern)
        do ianiso=1,maxaniso
         wkntop  =  akern(ianiso)*seis * tp * cz_conjg
         wkn(ly,ianiso) = (-1.0d0)*aimag(wkntop/wseisbot)
       enddo ! end of anisotropy loop
       enddo ! end of layer loop


       return
       end


       subroutine  layer_coeff(sphi,ang2,ly,akern)
       use eigen_functions
       use synthetic_ray
       real akern(maxaniso)
        
       lym = ly+maxlay-maxrec

       RD = radius(lym)

! L-L
       if(is_love .eq. 1) then
       akern_C = 0.0
       akern_A = 0.0
       akern_F = 0.0
       akern_N = wn*wn*ww(ly)*ww(ly)*cos(2*sphi)/RD/RD
       akern_L = (dw(ly)-ww(ly)/RD) * (dw(ly)-ww(ly)/RD) * cos(sphi)
       akern_r = omega**2 * ww(ly)*ww(ly) * cos(sphi)
       endif

! R-R 
       if(is_love .eq. 2) then
       akern_C = du(ly)*du(ly)
       akern_A = (2*uu(ly)-wn*vv(ly))*(2*uu(ly)-wn*vv(ly))/RD/RD
       akern_F = du(ly)*(2*uu(ly)-wn*vv(ly))/RD + du(ly)*(2*uu(ly)-wn*vv(ly))/RD
       akern_N = ((-1)*(2*uu(ly)-wn*vv(ly))*(2*uu(ly)-wn*vv(ly))+wn*wn*vv(ly)*vv(ly)*cos(2*sphi))/RD/RD
       akern_L = (dv(ly)-vv(ly)/RD+wn*uu(ly)/RD)* (dv(ly)-vv(ly)/RD+wn*uu(ly)/RD) * cos(sphi)
        akern_r = omega**2 * ( uu(ly)*uu(ly) + vv(ly)*vv(ly) * cos(sphi) )
        endif


! a minus sign before E:E*

        akern_C = akern_C * (-1.0)
        akern_A = akern_A * (-1.0)
        akern_F = akern_F * (-1.0)
        akern_N = akern_N * (-1.0)
        akern_L = akern_L * (-1.0)


! to Kbeta (for delta_bv/bv delta delta_bh/bh ... delta_ani/ani 
        akern_bv = 2*rho(lym)*bv(lym)
        akern_bv = akern_bv *(akern_L - 2*ani(lym)*akern_F)*bv(lym) 
        akern_bh = 2*rho(lym)*bh(lym)*akern_N*bh(lym) 
        akern_av = 2*rho(lym)*av(lym)*akern_C*av(lym) 
        akern_ah = 2*rho(lym)*ah(lym)
        akern_ah = akern_ah *(akern_A+ani(lym)*akern_F)*ah(lym) 
        akern_et = rho(lym) * ( ah(lym)**2-2*bv(lym)**2 )
        akern_et = akern_et *akern_F * ani(lym) 


! Krho delta rho / rho 
       akern_rho = akern_r
       akern_rho = akern_rho + ah(lym)**2*(akern_A+ani(lym)*akern_F)
       akern_rho = akern_rho + av(lym) **2 * akern_C
       akern_rho = akern_rho + bv(lym)**2 * (akern_L - 2 * ani(lym)*akern_F)
       akern_rho = akern_rho + bh(lym) **2 * akern_N
       akern_rho = akern_rho * rho(lym)

! receiver term       
        if(is_uvw.eq.1) receiver_term = UU(maxrec) 
        if(is_uvw.eq.2) receiver_term = ( VV(maxrec)*sin(ang2) - WW(maxrec)*cos(ang2) )
        if(is_uvw.eq.3) receiver_term = ( VV(maxrec)*cos(ang2) + WW(maxrec)*sin(ang2) )

       akern(1) = akern_av * receiver_term
       akern(2) = akern_ah * receiver_term
       akern(3) = akern_bv * receiver_term
       akern(4) = akern_bh * receiver_term
       akern(5) = akern_et * receiver_term
       akern(6) = akern_rho * receiver_term
        return
        end


       subroutine dis1(is_major,blo,distdeg1,dist1)
       use constant_para
       use synthetic_ray
       dist1 = distdeg1*pi/180
       if(is_major.eq.1.or.is_major.eq.3) tlong = (-1)*blo 
       if(is_major.eq.0.or.is_major.eq.2) tlong = blo 

       if(tlong.gt.180.and.tlong.lt.360) dist1 =  twopi - dist1 
       if(tlong.gt.360.and.tlong.lt.540)  dist1 = twopi + dist1 
       if(tlong.gt.540.and.tlong.lt.720)  dist1 = 2*twopi - dist1 
       return
       end

       subroutine dis2(is_major,blo,distdeg2,dist2)
       use constant_para
       use synthetic_ray
       dist2 = distdeg2*pi/180
       if(is_major.eq.1.or.is_major.eq.3) tlong = dist_act - (-1)*blo 
       if(is_major.eq.0.or.is_major.eq.2) tlong = dist_act - blo 

       if(tlong.gt.180.and.tlong.lt.360) dist2 =  twopi - dist2 
       if(tlong.gt.360.and.tlong.lt.540)  dist2 = twopi + dist2 
       if(tlong.gt.540.and.tlong.lt.720)  dist2 = 2*twopi - dist2 
       return
       end

       
        subroutine angcal(blo,bla,sphi,ang2)
        use constant_para
        use synthetic_ray
            cla = 0 
            clo = 0 
            rla = bla 
            rlo = blo
            call distaz(cla,clo,rla,rlo,dist1,az12,az21)
            cla = bla
            clo = blo
            rla = 0
            rlo = dist_act
            call distaz(cla,clo,rla,rlo,distdeg2,bz12,bz21)

            ak1 = az21 + 180
            ak2 = bz12
             
            ang2 = bz21 - 180
            sphi = ak2-ak1 ! ccw from k1 to k2
            if(sphi .gt. 180)  sphi = sphi  - 360
            if(sphi .lt. -180) sphi = sphi  + 360
        return
        end



        subroutine distaz(lat1,lon1,lat2,lon2,distdeg,az12deg,az21deg)
        use constant_para
        implicit double precision (a-h)
        real lat1,lon1,lat2,lon2,distdeg,az12deg,az21deg

        slat1 = sin(lat1*pi/180)
        clat1 = cos(lat1*pi/180)
        slon1 = sin(lon1*pi/180)
        clon1 = cos(lon1*pi/180)

        slat2 = sin(lat2*pi/180)
        clat2 = cos(lat2*pi/180)
        slon2 = sin(lon2*pi/180)
        clon2 = cos(lon2*pi/180)

        a1 = clat1 * clon1
        b1 = clat1 * slon1
        g1 = slat1 * clon1
        h1 = slat1 * slon1

        a2 = clat2 * clon2
        b2 = clat2 * slon2
        g2 = slat2 * clon2
        h2 = slat2 * slon2

        c1 = a1 * a2 + b1 * b2 + slat1 * slat2
        if(abs(c1).lt.0.94) then
        distrad = acos(c1)
        else
        if(c1.gt.0) then
        distrad = asin(sqrt((a1 - a2) * (a1 - a2) + (b1 - b2) * (b1 - b2) + (slat1 - slat2) * (slat1 - slat2)) / 2.) * 2.
        else
        distrad = acos(sqrt((a1 + a2) * (a1 + a2) + (b1 + b2) * (b1 + b2) + (slat1 + slat2) * (slat1 + slat2)) / 2.) * 2.
        endif
        endif
        
        distdeg = distrad * R2D
        
        c3 = (a2 - slon1) * (a2 - slon1) + (b2 + clon1) * (b2 + clon1) + slat2 * slat2 - 2.
        c4 = (a2 - g1) * (a2 - g1) + (b2 - h1) * (b2 - h1) + (slat2 + clat1) * (slat2 + clat1) - 2.
        az12rad = atan2(c3, c4)
        az12deg = az12rad * R2D

        
        c5 = (a1 - slon2) * (a1 - slon2) + (b1 + clon2) * (b1 + clon2) + slat1 * slat1 - 2.
        c6 = (a1 - g2) * (a1 - g2) + (b1 - h2) * (b1 - h2) + (slat1 + clat2) * (slat1 + clat2) - 2.
        az21rad = atan2(c5, c6)
        az21deg = az21rad * R2D

        if(az12deg.lt. 0)  az12deg = az12deg + 360
        if(az21deg.lt. 0)  az21deg = az21deg + 360

! ccw from south -180 -- 180 
        az12deg = 180 - az12deg 
        az21deg = 180 - az21deg 

        if(az12deg.lt. 0)  az12deg = az12deg + 360
        if(az21deg.lt. 0)  az21deg = az21deg + 360
        
        return
        end



