c This program prepares eigenfunctions generated by minos_bran
c for surface wave kernel calculation
c
c it reads minos_bran eigenfunctions, normalize them and store 
c eigenfunctions in the uppermost 800 km  in directory eigfs/
c
c To compile:   Intel Fortran:  ifort -132 -w -o read_eigf read_eigf.f 
c
c To run:       read_eigf  (1 for Love wave and 2 for Rayleigh wave)
c
c
c  Ying Zhou (ying.yingzhou@gmail.com)
c  May 2013
c

        character*2 modeindex
        parameter(ndim = 600)
        real*4 buf(ndim*6+5)
        real*4 WW, DW, UU, DU, VV, DV
        real r(ndim), rho(ndim),vpv(ndim),vsv(ndim)
        real, parameter :: twopi = 3.14159265*2
        real, parameter :: RR0 = 6371000
        real, parameter :: fnorm = 201.54036
        character(len=70) title


        write(*,*)'love (1)  or rayleigh (2)'
        read(*,*)is_love

        if(is_love .eq. 1) then
        open(10,file="love.out")
        open(20,file="eigf.love",form='unformatted')
        endif
        if(is_love .eq. 2) then
        open(10,file="rayleigh.out")
        open(20,file="eigf.rayleigh",form='unformatted')
        endif

        read(10,'(a)')title
        read(10,910) ifanis,tref,ifdeck
        read(10,911) maxlay,nic,noc,rx

  100   format(('a'))   
  910   format(i5,f7.1,2x,i5)
  911   format(3(i5,1x),2x,f7.2)
  905   format(3x,i3,f12.1,2f12.2,2f12.2,f12.5,3f12.2)

        open(40,file='eigfs/model')
        write(40,*)title
        write(40,910) ifanis,tref,ifdeck
        write(40,911)maxlay,nic,noc,rx
        
c    read model lines in the output file love.out/rayleigh.out 
        radius_800 = 6371000 - 800*1000
        nlay = 0
        do i = 1, maxlay 
        read(10,*)j,r(i),rho(i),vpv(i),vph,vsv(i),vsh,eta,qshear,qkappa
        write(40,905)j,r(i),rho(i),vpv(i),vsv(i),qkappa,qshear,vph,vsh,eta
        if( r(i) .gt. radius_800) nlay = nlay + 1 
        enddo 
        close(40)

        ! ignore lines
        read(10,*)
        read(10,*)
        read(10,*)
        ! start layer from 800 km depth to surface
        ls00 = maxlay - nlay + 1

! read eigenfunctions and prepare output files for ffswk.for      
 
        ! output files       
        if(is_love .eq. 1) then
        open(60,file="eigfs/layer.love.0")
        open(70,file="eigfs/eigf.love.0",form='unformatted')
        endif
        if(is_love .eq. 2) then
        open(60,file="eigfs/layer.rayleigh.0")
        open(70,file="eigfs/eigf.rayleigh.0",form='unformatted')
        endif
        
        write(60,*)'omega  vphase gcom layer_number strat  end'

200     read(10,*,err=201,end=201)nord,l,cvel,wmhz,tcom,gcom,qmod,wdiff
        cvel = cvel * 1000
        gcom = gcom * 1000
        qmod = 1.0/qmod
        write(70)nord,l,cvel,wmhz,tcom,gcom,qmod,wdiff

        if(is_love. eq. 1) read(20)nn,ll,freq,qq,gc,(buf(j),j=1,2*maxlay)
        if(is_love. eq. 2) read(20)nn,ll,freq,qq,gc,(buf(j),j=1,6*maxlay)

        omega = twopi * wmhz * 0.001
        cvel = cvel*1000
        gcom = gcom*1000

        write(60,91)omega,cvel,gcom,nlay,ls00,maxlay
91      format(1x,e11.4,1x,f12.2,1x,f12.2,1x,i5,i5,i5)
        
        fl = float(ll)
        fl3 = sqrt(fl*(fl+1))
        do j = ls00, maxlay 
            if(is_love .eq. 1) then
            WW = buf(j)/fl3/RR0/fnorm
            DW = buf(j+maxlay)/fl3/RR0/RR0/fnorm
            write(70)WW,DW
            endif
            if(is_love .eq. 2) then
            UU = (-1)*buf(j)/RR0/fnorm
            DU = (-1)*buf(j+maxlay)/RR0/RR0/fnorm
            VV = (-1)*buf(j+maxlay*2)/fl3/RR0/fnorm
            DV = (-1)*buf(j+maxlay*3)/fl3/RR0/RR0/fnorm
            write(70)UU,DU,VV,DV
            endif
        enddo
        goto 200
201     continue

        close(10)
        close(60)
        close(70)
        stop
        end

